{
    "$graph": [
        {
            "class": "CommandLineTool",
            "id": "#gatk-GenotypeGVCFs.cwl",
            "label": "gatk-GenotypeGVCFs-v4.0.11.0",
            "requirements": [
                {
                    "dockerPull": "broadinstitute/gatk:4.0.11.0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "gatk",
                "--java-options",
                "-Xmx4G",
                "GenotypeGVCFs"
            ],
            "inputs": [
                {
                    "type": "string",
                    "doc": "Output gVCF file name",
                    "default": "variants.genotype.vcf.gz",
                    "inputBinding": {
                        "prefix": "--output"
                    },
                    "id": "#gatk-GenotypeGVCFs.cwl/gatk-GenotypeGVCFs-v4.0.11.0/output"
                },
                {
                    "type": "File",
                    "doc": "Reference FASTA file",
                    "inputBinding": {
                        "prefix": "--reference"
                    },
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#gatk-GenotypeGVCFs.cwl/gatk-GenotypeGVCFs-v4.0.11.0/reference"
                },
                {
                    "type": "File",
                    "doc": "Input VCF file",
                    "inputBinding": {
                        "prefix": "--variant"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk-GenotypeGVCFs.cwl/gatk-GenotypeGVCFs-v4.0.11.0/variant"
                }
            ],
            "arguments": [],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk-GenotypeGVCFs.cwl/gatk-GenotypeGVCFs-v4.0.11.0/vcf"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk-HaplotypeCaller.cwl",
            "label": "gatk-HaplotypeCaller-v4.0.11.0",
            "requirements": [
                {
                    "dockerPull": "broadinstitute/gatk:4.0.11.0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "gatk",
                "--java-options",
                "-Xmx4G",
                "HaplotypeCaller"
            ],
            "inputs": [
                {
                    "type": "string",
                    "doc": "Mode for emitting reference confidence scores [GVCF(=default) or BP_RESOLUTION]",
                    "default": "GVCF",
                    "inputBinding": {
                        "prefix": "--emit-ref-confidence"
                    },
                    "id": "#gatk-HaplotypeCaller.cwl/gatk-HaplotypeCaller-v4.0.11.0/emit-ref-conf"
                },
                {
                    "type": "File",
                    "doc": "Input BAM file",
                    "inputBinding": {
                        "prefix": "--input"
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#gatk-HaplotypeCaller.cwl/gatk-HaplotypeCaller-v4.0.11.0/input"
                },
                {
                    "type": "string",
                    "doc": "Output gVCF file name",
                    "default": "variants.g.vcf.gz",
                    "inputBinding": {
                        "prefix": "--output"
                    },
                    "id": "#gatk-HaplotypeCaller.cwl/gatk-HaplotypeCaller-v4.0.11.0/output"
                },
                {
                    "type": "File",
                    "doc": "Reference FASTA file",
                    "inputBinding": {
                        "prefix": "--reference"
                    },
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#gatk-HaplotypeCaller.cwl/gatk-HaplotypeCaller-v4.0.11.0/reference"
                }
            ],
            "arguments": [
                {
                    "id": "#gatk-HaplotypeCaller.cwl/gatk-HaplotypeCaller-v4.0.11.0/max-alt-alleles",
                    "prefix": "-max-alternate-alleles",
                    "valueFrom": "2"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk-HaplotypeCaller.cwl/gatk-HaplotypeCaller-v4.0.11.0/vcf"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk-SelectVariants.cwl",
            "label": "gatk-SelectVariants-v4.0.11.0",
            "requirements": [
                {
                    "dockerPull": "broadinstitute/gatk:4.0.11.0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "gatk",
                "--java-options",
                "-Xmx4G",
                "SelectVariants"
            ],
            "inputs": [
                {
                    "type": "string",
                    "doc": "Output VCF file name",
                    "default": "variants.varonly.vcf.gz",
                    "inputBinding": {
                        "prefix": "--output"
                    },
                    "id": "#gatk-SelectVariants.cwl/gatk-SelectVariants-v4.0.11.0/output"
                },
                {
                    "type": "File",
                    "doc": "Reference FASTA file",
                    "inputBinding": {
                        "prefix": "--reference"
                    },
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#gatk-SelectVariants.cwl/gatk-SelectVariants-v4.0.11.0/reference"
                },
                {
                    "type": "File",
                    "doc": "Input VCF file",
                    "inputBinding": {
                        "prefix": "--variant"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk-SelectVariants.cwl/gatk-SelectVariants-v4.0.11.0/variant"
                }
            ],
            "arguments": [
                {
                    "id": "#gatk-SelectVariants.cwl/gatk-SelectVariants-v4.0.11.0/option1",
                    "prefix": "--select-type-to-include",
                    "valueFrom": "SNP"
                },
                {
                    "id": "#gatk-SelectVariants.cwl/gatk-SelectVariants-v4.0.11.0/option2",
                    "prefix": "--select-type-to-include",
                    "valueFrom": "INDEL"
                },
                {
                    "id": "#gatk-SelectVariants.cwl/gatk-SelectVariants-v4.0.11.0/filter-name",
                    "valueFrom": "--exclude-filtered"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk-SelectVariants.cwl/gatk-SelectVariants-v4.0.11.0/vcf"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk-VariantFiltration.cwl",
            "label": "gatk-VariantFiltration-v4.0.11.0",
            "requirements": [
                {
                    "dockerPull": "broadinstitute/gatk:4.0.11.0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "gatk",
                "--java-options",
                "-Xmx4G",
                "VariantFiltration"
            ],
            "inputs": [
                {
                    "type": "string",
                    "doc": "Filter condition",
                    "default": "QD < 5.0 || FS > 50.0 || SOR > 3.0 || MQ < 50.0 || MQRankSum < -2.5 || ReadPosRankSum < -1.0 || ReadPosRankSum > 3.5",
                    "inputBinding": {
                        "prefix": "--filter-expression"
                    },
                    "id": "#gatk-VariantFiltration.cwl/gatk-VariantFiltration-v4.0.11.0/filter-expression"
                },
                {
                    "type": "string",
                    "doc": "Output VCF file name",
                    "default": "variants.filter.genotype.vcf.gz",
                    "inputBinding": {
                        "prefix": "--output"
                    },
                    "id": "#gatk-VariantFiltration.cwl/gatk-VariantFiltration-v4.0.11.0/output"
                },
                {
                    "type": "File",
                    "doc": "Reference FASTA file",
                    "inputBinding": {
                        "prefix": "--reference"
                    },
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#gatk-VariantFiltration.cwl/gatk-VariantFiltration-v4.0.11.0/reference"
                },
                {
                    "type": "File",
                    "doc": "Input VCF file",
                    "inputBinding": {
                        "prefix": "--variant"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk-VariantFiltration.cwl/gatk-VariantFiltration-v4.0.11.0/variant"
                }
            ],
            "arguments": [
                {
                    "id": "#gatk-VariantFiltration.cwl/gatk-VariantFiltration-v4.0.11.0/filter-name",
                    "prefix": "--filter-name",
                    "valueFrom": "FILTER"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk-VariantFiltration.cwl/gatk-VariantFiltration-v4.0.11.0/vcf"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#main/bam"
                },
                {
                    "type": "string",
                    "doc": "VCF filter condition for GATK-VariantFiltration",
                    "default": "QD < 5.0 || FS > 50.0 || SOR > 3.0 || MQ < 50.0 || MQRankSum < -2.5 || ReadPosRankSum < -1.0 || ReadPosRankSum > 3.5",
                    "id": "#main/filter-expression"
                },
                {
                    "type": "string",
                    "doc": "Any string that can distinguish sample.",
                    "id": "#main/outprefix"
                },
                {
                    "type": "File",
                    "doc": "FASTA file for reference genome",
                    "secondaryFiles": [
                        "^.dict",
                        ".fai"
                    ],
                    "id": "#main/reference"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#main/threads"
                }
            ],
            "steps": [
                {
                    "run": "#gatk-GenotypeGVCFs.cwl",
                    "in": [
                        {
                            "source": "#main/reference",
                            "id": "#main/genotype_gvcf/reference"
                        },
                        {
                            "source": "#main/haplotype_caller/vcf",
                            "id": "#main/genotype_gvcf/variant"
                        }
                    ],
                    "out": [
                        "#main/genotype_gvcf/vcf"
                    ],
                    "id": "#main/genotype_gvcf"
                },
                {
                    "run": "#gatk-HaplotypeCaller.cwl",
                    "in": [
                        {
                            "source": "#main/bam",
                            "id": "#main/haplotype_caller/input"
                        },
                        {
                            "source": "#main/outprefix",
                            "valueFrom": "variants_$(self).g.vcf.gz",
                            "id": "#main/haplotype_caller/output"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/haplotype_caller/reference"
                        }
                    ],
                    "out": [
                        "#main/haplotype_caller/vcf"
                    ],
                    "id": "#main/haplotype_caller"
                },
                {
                    "run": "#gatk-SelectVariants.cwl",
                    "in": [
                        {
                            "source": "#main/outprefix",
                            "valueFrom": "${ return \"variants_\" + self + \".varonly.vcf.gz\"}",
                            "id": "#main/select_variants/output"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/select_variants/reference"
                        },
                        {
                            "source": "#main/variant_filtration/vcf",
                            "id": "#main/select_variants/variant"
                        }
                    ],
                    "out": [
                        "#main/select_variants/vcf"
                    ],
                    "id": "#main/select_variants"
                },
                {
                    "run": "#gatk-VariantFiltration.cwl",
                    "in": [
                        {
                            "source": "#main/filter-expression",
                            "id": "#main/variant_filtration/filter-expression"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/variant_filtration/reference"
                        },
                        {
                            "source": "#main/genotype_gvcf/vcf",
                            "id": "#main/variant_filtration/variant"
                        }
                    ],
                    "out": [
                        "#main/variant_filtration/vcf"
                    ],
                    "id": "#main/variant_filtration"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/haplotype_caller/vcf",
                    "id": "#main/hc_gvcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/select_variants/vcf",
                    "id": "#main/varonly_vcf"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
